# $Revision: 1.113 $, $Date: 2006/09/26 14:14:31 $
Summary:	Linux kernel headers for use with C libraries
Summary(pl):	Nagwki jdra Linuksa do uytku z bibliotekami C
Name:		linux-libc-headers
Version:	2.6.12.0
Release:	14
Epoch:		7
License:	GPL
Group:		Development
Source0:	http://ep09.pld-linux.org/~mmazur/linux-libc-headers/%{name}-%{version}.tar.bz2
# Source0-md5:	eae2f562afe224ad50f65a6acfb4252c
Source1:	%{name}-dv1394.h
Source2:	%{name}-ieee1394-ioctl.h
Patch0:		%{name}-esfq.patch
Patch1:		%{name}-wrr.patch
Patch2:		%{name}-netfilter.patch
Patch3:		%{name}-fbsplash.patch
Patch4:		%{name}-tc-u32-mark.patch
Patch5:		%{name}-imq.patch
Patch6:		%{name}-endian.patch
# based on http://people.redhat.com/sgrubb/audit/audit.h
Patch7:		%{name}-audit.patch
Patch8:		%{name}-partial-2.6.15.patch
Patch9:		%{name}-nfc.patch
Patch10:	linux-headers-2.6.17.11-08232006-unistd_x86_PIC-1.patch
AutoReqProv:	no
BuildRequires:	rpmbuild(macros) >= 1.213
Requires(pre):	fileutils
Provides:	alsa-driver-devel
Provides:	glibc-kernel-headers = %{epoch}:%{version}-%{release}
Provides:	i2c-devel = 2.8.2
Obsoletes:	alsa-driver-devel
Obsoletes:	glibc-kernel-headers
Obsoletes:	glibc-kernheaders
Conflicts:	lm_sensors-devel < 2.8.2-2
ExclusiveOS:	Linux
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip		1

%ifarch %{x8664} ppc64 s390x sparc sparc64 sparcv9
%define		dodual	1
%else
%define		dodual	0
%endif

%description
This package includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs. The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package.

%description -l pl
Ten pakiet zawiera pliki nagwkowe C, ktre definiuj interfejs
midzy jdrem Linuksa a bibliotekami i programami dziaajcymi w
przestrzeni uytkownika. Pliki nagwkowe definiuj struktury i stae
potrzebne do zbudowania wikszoci standardowych programw, s take
potrzebne do przebudowania pakietu glibc.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
%ifarch %{x8664}
a1=i386
a2=x86_64
c1='defined(__i386__)'
c2='defined(__x86_64__)'
cond1=
%endif
%ifarch ppc64
a1=ppc
a2=ppc64
c1='defined(__powerpc__) && !defined(__powerpc64__)'
c2='defined(__powerpc64__)'
%endif
%ifarch s390 s390x
a1=sparc
a2=sparc64
c1='defined(__s390__) && !defined(__s390x__)'
c2='defined(__s390x__)'
%endif
%ifarch sparc sparcv9 sparc64
a1=sparc
a2=sparc64
c1='defined(__sparc__) && !defined(__arch64__)'
c2='defined(__sparc__) && defined(__arch64__)'
%endif

%if %{dodual}
cd include
rm -f asm
mkdir asm

for h in `( ls asm-${a1}; ls asm-${a2} ) | grep '\.h$' | sort -u`; do
	name=`echo $h | tr a-z. A-Z_`
	# common header
	cat > asm/$h << EOF
/* All asm/ files are generated and point to the corresponding
 * file in asm-${a1} or asm-${a2}.
 */

#ifndef __ASM_STUB_${name}__
#define __ASM_STUB_${name}__

#  if ${c1}
EOF

	if [ -f asm-${a1}/$h ]; then
		echo "#    include <asm-${a1}/$h>" >> asm/$h
	else
		echo "#    error <asm-${a1}/$h> does not exist" >> asm/$h
	fi

	cat >> asm/$h <<EOF
#  endif
#  if ${c2}
EOF

	if [ -f asm-${a2}/$h ]; then
		echo "#    include <asm-${a2}/$h>" >> asm/$h
	else
		echo "#    error <asm-${a2}/$h> does not exist" >> asm/$h
	fi

	# common footer
	cat >> asm/$h <<EOF
#  endif

#endif /* !__ASM_STUB_${name}__ */
EOF

done
echo "asm asm-${a1} asm-${a2}" > asmdirs
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_includedir}

cd include
%if %{dodual}
cp -a `cat asmdirs` $RPM_BUILD_ROOT%{_includedir}
%else
cp -a asm-%{_target_base_arch} $RPM_BUILD_ROOT%{_includedir}/asm
%endif
cp -a linux $RPM_BUILD_ROOT%{_includedir}
cp -a sound $RPM_BUILD_ROOT%{_includedir}

install -d $RPM_BUILD_ROOT%{_includedir}/linux/ieee1394/
install %{SOURCE1} $RPM_BUILD_ROOT%{_includedir}/linux/ieee1394/dv1394.h
install %{SOURCE2} $RPM_BUILD_ROOT%{_includedir}/linux/ieee1394/ieee1394-ioctl.h

find $RPM_BUILD_ROOT%{_includedir} -type f \
	'(' -name '*.orig' -o -name '*~' ')' | xargs -r rm

%clean
rm -rf $RPM_BUILD_ROOT

%pre
[ ! -L /usr/include/linux ] || rm -f /usr/include/linux
[ ! -L /usr/include/asm ] || rm -f /usr/include/asm
[ ! -L /usr/include/sound ] || rm -f /usr/include/sound
%ifarch sparc sparcv9 sparc64
[ ! -L /usr/include/asm-sparc ] || rm -f /usr/include/asm-sparc
[ ! -L /usr/include/asm-sparc64 ] || rm -f /usr/include/asm-sparc64
%endif

%files
%defattr(644,root,root,755)
%{_includedir}/linux
%{_includedir}/asm*
%{_includedir}/sound

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: linux-libc-headers.spec,v $
Revision 1.113  2006/09/26 14:14:31  mguevara
- rel 14 adds linux-headers-2.6.17.11-08232006-unistd_x86_PIC-1.patch
  (patch10) which adds position independent assembly for syscalls.

Revision 1.112  2006/04/22 21:40:56  arekm
- rel 13; added new definitions to rtnetlink.h

Revision 1.111  2006/04/16 19:50:28  glen
- rel 12: update netfilter headers for frox to build (using copy of libiptc from iptables 1.2)

Revision 1.110  2006/01/10 21:16:06  arekm
- rel 11; updated some things needed by new iproute2

Revision 1.109  2005/11/24 10:59:02  pluto
- ipset stuff added, release 10.

Revision 1.108  2005/11/14 09:31:04  pluto
- esfq updated, release 9.

Revision 1.107  2005/11/10 13:38:49  arekm
- add linux-libc-headers-partial-2.6.14.patch (changes needed for new iproute2)

Revision 1.106  2005/10/30 16:16:45  arekm
- one more header added (ieee1394-ioctl.h)

Revision 1.105  2005/10/30 16:02:13  arekm
- rel 6; add dv1394.h

Revision 1.104  2005/10/05 16:54:56  arekm
- rel 5

Revision 1.103  2005/08/28 16:21:31  glen
- there's no such tool to regenerate asm stub headers

Revision 1.102  2005/08/28 16:14:56  glen
- my build system doesn't generate .orig files on patching (but ~ instead)
  and others could be off completely due $VERSION_CONTROL variable,
  in other words, add -r option to xargs

Revision 1.101  2005/08/28 14:39:56  qboosh
- added audit patch, release 4

Revision 1.100  2005/08/23 17:48:17  qboosh
- bugfix in endian patch, release 3

Revision 1.99  2005/08/23 17:23:22  qboosh
- added endian patch, release 2

Revision 1.98  2005/08/04 19:33:48  pluto
- imq headers added.
- release 1.

Revision 1.97  2005/08/02 19:50:40  pluto
- updated to 2.6.12.0, nfy, dnt.

Revision 1.96  2005/05/23 16:05:36  pluto
- remove trash from files, release 5.

Revision 1.95  2005/05/11 15:27:01  qboosh
- use x8664 macro

Revision 1.94  2005/05/06 21:26:32  pluto
- netfiler patch updated for 2.6.11.8-3 kernel.

Revision 1.93  2005/04/03 08:04:23  pluto
- esfq no longer interferes with the original sfq.
- release 3.

Revision 1.92  2005/04/02 13:11:25  pluto
- the tc_u32_mark structure is used as part of the netlink message
  from the user API to the kernel, so it needs to be moved to
  include/linux/pkt_cls.h. also, the definition of u32 performance
  counters doesn't need to depend on the config option.
  the definition can exist even if the code isn't enabled.
- release 2.

Revision 1.91  2005/03/30 19:09:13  qboosh
- removed obsolete ethtool patch

Revision 1.90  2005/03/30 15:57:25  pluto
- updated to 2.6.11.2.
- release 1.

Revision 1.89  2005/03/26 19:39:09  qboosh
- added ethtool patch, release 2

Revision 1.88  2005/03/25 22:48:04  pluto
- updated to 2.6.11.1.
- release 1.

Revision 1.87  2005/03/25 21:59:01  pluto
- netfilter patch updated (+= ipt_connlimit.h).
- release 5.

Revision 1.86  2005/03/17 11:29:06  pluto
- netfilter patch is now frozen (it's common for 2_6{,_11} kernel branches).
- release 4.

Revision 1.85  2005/03/17 10:03:25  cieciwa
- release 3 - to fix problem.

Revision 1.84  2005/03/15 15:01:15  cieciwa
- release 2,
- updated netfilter headers.

Revision 1.83  2005/03/13 22:41:36  pluto
- updated to 2.6.11.0.

Revision 1.82  2005/02/18 18:32:15  qboosh
- no complaints? release 3

Revision 1.81  2005/02/15 19:46:30  qboosh
- package wrappers when biarch

Revision 1.80  2005/02/15 19:38:21  qboosh
- biarch on amd64, ppc64, s390/s390x (untested)

Revision 1.79  2005/01/25 09:18:41  pluto
- release 2 (iproute2 needs patched headers).

Revision 1.78  2005/01/20 08:38:49  kosmo
- added linux-libc-headers-match-nfmark-in-u32.patch

Revision 1.77  2005/01/09 00:34:02  pluto
- release 1.

Revision 1.76  2005/01/09 00:11:44  pluto
- updated to 2.6.10.0.
- netfilter updated.

Revision 1.75  2005/01/08 04:21:45  havner
- fbsplash
- rel 1.5

Revision 1.74  2004/12/11 13:05:22  pluto
- minor hack for missed list_head struct.
- release 1.4.

Revision 1.73  2004/12/11 12:45:05  pluto
- s/#include <linux/tcp.h>/#include <netinet/tcp.h>/
- release 1.3.

Revision 1.72  2004/12/11 12:26:57  pluto
- netfilter patch updated for 2.6.10-0.30.
- release 1.2.

Revision 1.71  2004/11/27 18:40:58  qboosh
- typo

Revision 1.70  2004/11/07 21:37:00  qboosh
- updated to 2.6.9.1, updated wrr,netfilter patches
- removed obsolete alsa-1.0.6 and (already dropped) pom-ng-20040907 patches
- dropped unistd patch - apps must be fixed

Revision 1.69  2004/09/27 12:17:59  cieciwa
- release 4;
- removed patch5 - new netfilter support - not exist in kernel.

Revision 1.68  2004/09/20 18:49:00  havner
- unistd patch
- rel 3

Revision 1.67  2004/09/14 08:57:35  cieciwa
- release 2,
- added support for netfilter snap 20040907 [osf and u32].

Revision 1.66  2004/08/29 20:55:13  qboosh
- comment Patch4 too

Revision 1.65  2004/08/29 20:16:24  mmazur
- commented out -updates.patch; patch (the app) is stupid - should have
  bailed out with a conflict

Revision 1.64  2004/08/29 20:13:09  mmazur
- 2.6.8.1

Revision 1.63  2004/08/23 21:06:20  qboosh
- added update patch (<linux/msdos_fs.h> fix), release 4

Revision 1.62  2004/08/22 20:57:54  qboosh
- release 3

Revision 1.61  2004/08/20 06:23:26  pluto
- alsa updated to 1.0.6.
- release 2.

Revision 1.60  2004/08/19 19:41:11  arekm
- updated to 2.6.8 aka tribute to mmazur - maintainer of VANILLA (ONLY) llh

Revision 1.59  2004/08/04 17:46:48  arekm
- fix pkt_sched.h

Revision 1.58  2004/08/04 17:25:47  arekm
- wrr patch is broken

Revision 1.57  2004/07/29 13:35:15  qboosh
- release 8

Revision 1.56  2004/07/28 11:48:40  arekm
- drop pkt patch since that incompatible change was reverted in kernel bk

Revision 1.55  2004/07/17 21:53:18  arekm
- add new things from our kernels so iproute will work well (tc)

Revision 1.54  2004/07/14 11:02:33  pluto
- netfilter patch updated.
- tagged as LINUX_2_6_7-2.
- release 6.

Revision 1.53  2004/07/11 16:57:40  qboosh
- added ia64 patch, release 5

Revision 1.52  2004/07/03 20:49:37  pluto
- netfilter updated, release 4.

Revision 1.51  2004/07/03 19:10:08  qboosh
- release 3 (removed breaking parts from netfilter patch)

Revision 1.50  2004/07/03 16:42:02  qboosh
- release 2 (netfilter patch updated by cieciwa)

Revision 1.49  2004/06/27 20:03:14  qboosh
- updated to 2.6.7.0, removed obsolete newtcp patch

Revision 1.48  2004/06/20 12:50:44  pluto
- netfilter.patch fixed, release 4.

Revision 1.47  2004/06/20 10:31:48  pluto
- netfilter updated, release 3.

Revision 1.46  2004/06/19 14:39:31  pluto
- simplified.

Revision 1.45  2004/06/19 14:17:06  pluto
- [sparc(32/64)]: don't overwrite wrappers.

Revision 1.44  2004/06/16 18:37:24  arekm
- new tcp stats; rel 2

Revision 1.43  2004/06/13 20:48:36  arekm
- updated to 2.6.6.0

Revision 1.42  2004/05/22 16:19:43  pluto
- netfilter_ipv4: ipt_account.h added.
- release 6.

Revision 1.41  2004/05/19 08:58:13  pluto
- netfilter updated to 20040518.
- release 5.

Revision 1.40  2004/05/08 16:56:13  pluto
- WRR patch added.
- release 4.

Revision 1.39  2004/05/07 21:49:15  pluto
- esfq patch fixed.
- release 3.

Revision 1.38  2004/05/07 14:00:21  areq
- add update.patch (removed conflicts with net/if.h)

Revision 1.37  2004/05/02 23:14:28  mmazur
- up to 2.6.5.1

Revision 1.36  2004/04/29 17:42:28  pluto
- netfilter updated to 20040429.
- release 2.

Revision 1.35  2004/04/25 17:37:54  pluto
- release 1.

Revision 1.34  2004/04/25 17:25:35  pluto
- wrr removed from patch. it's already in llh.

Revision 1.33  2004/04/25 16:33:35  qboosh
- added update patch (fixes strace build on amd64); waiting for patches 1-2

Revision 1.32  2004/04/24 13:00:41  mmazur
- forgot to update md5

Revision 1.31  2004/04/24 12:54:35  mmazur
- up to 2.6.5.0; nfy - pluto check netfilter status :)

Revision 1.30  2004/04/16 20:45:43  pluto
- netfilter updated to 20040415.
- release 5.

Revision 1.29  2004/04/08 12:28:55  pluto
- netfilter update to 20040330.
- release 4.

Revision 1.28  2004/04/04 12:28:57  pluto
- esfq/wrr support added.
- release 3.

Revision 1.27  2004/03/31 08:18:34  qboosh
- added update patch (fixes two blocker bugs); release 2

Revision 1.26  2004/03/28 13:57:42  mmazur
- up to 2.6.4.0; nfy - pluto make your netfilter stuff

Revision 1.25  2004/03/25 18:01:56  pluto
- argh, #removed.

Revision 1.24  2004/03/25 18:00:28  pluto
- netfilter updated to 20040322.
- release 3.

Revision 1.23  2004/03/04 15:37:20  pluto
- netfilter update.
- release 2.

Revision 1.22  2004/02/29 16:43:17  mmazur
- up to 2.6.3.0

Revision 1.21  2004/02/22 21:44:40  mmazur
- if links /usr/include/sound found remove it before installation

Revision 1.20  2004/02/11 22:28:47  mmazur
- up to 2.6.2.0

Revision 1.19  2004/02/08 16:59:59  mmazur
- up to 2.6.1.3

Revision 1.18  2004/02/07 15:37:14  pluto
- ehh mmazur, empty field in spec ;)

Revision 1.17  2004/02/07 11:58:07  mmazur
- glibc-kernel-headers is now DEAD... BUAHAHAHAHAHA
- long live linux-libc-headers

Revision 1.16  2004/02/03 23:54:58  mmazur
- 2.6.1.2

Revision 1.15  2004/01/23 17:28:42  mmazur
- up to 2.6.1.1

Revision 1.14  2004/01/17 23:11:43  mmazur
- version 2.6.1.0

Revision 1.13  2004/01/05 18:51:11  mmazur
- 2.6.0.4

Revision 1.12  2003/12/31 23:56:46  mmazur
- up to 2.6.0.3

Revision 1.11  2003/12/26 19:21:47  mmazur
- up to 2.6.0.2; asm-generic is no more

Revision 1.10  2003/12/23 18:07:19  mmazur
- up to 2.6.0.1

Revision 1.9  2003/12/23 12:12:10  mmazur
- fix for %%pre as qboosh suggested

Revision 1.8  2003/12/22 20:08:39  mmazur
- up to 2.6.0.0; sending to builders

Revision 1.7  2003/12/20 14:29:16  qboosh
- uh, release 2

Revision 1.6  2003/12/20 14:28:49  qboosh
- Epoch 7 (glibc.spec with -kernel-headers had epoch 6)
- added i2c-devel version and Conflicts for lm_sensors-devel with linux/i2c-dev.h

Revision 1.5  2003/12/20 00:26:21  mmazur
- version 2.0

Revision 1.4  2003/12/18 11:17:07  jajcus
- kernel-only include removed from linux/a.out.h which is used during glibc compilation (name}-a.out.patch)

Revision 1.3  2003/12/14 17:03:33  mmazur
- epoch 1 to allow upgrades from pervious versions
- obsoletes: glibc-kernheaders

Revision 1.2  2003/12/14 15:33:25  mmazur
- added asm-generic. Need to check what exactly debian put's in

Revision 1.1  2003/12/13 23:43:09  mmazur
- First commit. Builds. Anybody care to test if glibc builds with it?
